package com.link.core.basic.aop;

import com.link.core.basic.database.DataSourceAspect;
import javax.annotation.Resource;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.springframework.core.annotation.Order;

@Aspect
@Order(-1)
public class DataSourceAspectAop {
   @Resource
   private DataSourceAspect dataSourceAspect;

   @Pointcut("execution(* com.link.base..service..*.*(..)) || execution(* com.link.core.basic.service..*.*(..))")
   public void queryFromDatabase() {
   }

   @Around("queryFromDatabase()")
   public Object dateSourcePointcut(ProceedingJoinPoint point) throws Throwable {
      return this.dataSourceAspect.changeDataSource(point);
   }
}
